## rust-wasmtime 21.0.2+dfsg

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(wasmtime-examples)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 11)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../crates/c-api ${CMAKE_CURRENT_BINARY_DIR}/wasmtime)

function(CREATE_TARGET TARGET TARGET_PATH)
	add_executable(wasmtime-${TARGET} ${TARGET_PATH})

	if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		target_compile_options(wasmtime-${TARGET} PRIVATE -Wall -Wextra -Wno-deprecated-declarations)
	elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
		target_compile_options(wasmtime-${TARGET} PRIVATE /W3)
	endif()

	set_target_properties(wasmtime-${TARGET} PROPERTIES
		OUTPUT_NAME wasmtime-${TARGET}
		RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/$<0:>
		CXX_VISIBILITY_PRESET hidden
		POSITION_INDEPENDENT_CODE ON)

	target_include_directories(wasmtime-${TARGET} PUBLIC wasmtime)
	target_link_libraries(wasmtime-${TARGET} PUBLIC wasmtime)
	if(APPLE)
		target_link_libraries(wasmtime-${TARGET} PRIVATE "-framework CoreFoundation")
	endif()
	add_test(NAME ${TARGET}-c COMMAND $<TARGET_FILE:wasmtime-${TARGET}> WORKING_DIRECTORY ../..)
endfunction()

function(CREATE_RUST_TEST EXAMPLE)
	if(ARGC GREATER 1)
		add_test(NAME ${EXAMPLE}-rust COMMAND cargo run --example ${EXAMPLE} --features ${ARGV1} WORKING_DIRECTORY ../..)
	else()
		add_test(NAME ${EXAMPLE}-rust COMMAND cargo run --example ${EXAMPLE} WORKING_DIRECTORY ../..)
	endif()
endfunction()
function(CREATE_RUST_WASM EXAMPLE TARGET)
	execute_process(COMMAND cargo build -p example-${EXAMPLE}-wasm --target ${TARGET})
endfunction()

# Enable testing
enable_testing()

# Add all examples
create_target(anyref anyref.c)
create_target(async async.cpp)
create_target(externref externref.c)
create_target(fib-debug fib-debug/main.c)
create_target(fuel fuel.c)
create_target(gcd gcd.c)
create_target(hello hello.c)
create_target(interrupt interrupt.c)
create_target(linking linking.c)
create_target(memory memory.c)
create_target(multi multi.c)
create_target(multimemory multimemory.c)
create_target(serialize serialize.c)
create_target(threads threads.c)
create_target(wasi wasi/main.c)

# Add rust tests
create_rust_test(anyref)
create_rust_wasm(fib-debug wasm32-unknown-unknown)
create_rust_wasm(tokio wasm32-wasi)
create_rust_wasm(wasi wasm32-wasi)
create_rust_wasm(component wasm32-unknown-unknown)
create_rust_test(epochs)
create_rust_test(externref)
create_rust_test(fib-debug)
create_rust_test(fuel)
create_rust_test(gcd)
create_rust_test(hello)
create_rust_test(interrupt)
create_rust_test(linking)
create_rust_test(memory)
create_rust_test(multi)
create_rust_test(multimemory)
create_rust_test(serialize)
create_rust_test(threads)
create_rust_test(wasi)
create_rust_test(tokio wasi-common/tokio)
create_rust_test(component)

=== crates/c-api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(wasmtime C)

set(WASMTIME_USER_CARGO_BUILD_OPTIONS "" CACHE STRING "Additional cargo flags (such as --features) to apply to the build command")
option(BUILD_SHARED_LIBS "Build using shared libraries" OFF)
option(WASMTIME_ALWAYS_BUILD "If cmake should always invoke cargo to build wasmtime" ON)
option(WASMTIME_FASTEST_RUNTIME "Set flags designed to optimize runtime performance" OFF)

if(WASMTIME_FASTEST_RUNTIME)
	set(WASMTIME_BUILD_TYPE_FLAG "--profile=fastest-runtime")
	set(WASMTIME_BUILD_TYPE "fastest-runtime")
	set(CARGO_PROFILE_PANIC CARGO_PROFILE_RELEASE_PANIC)
else()
	if(CMAKE_BUILD_TYPE STREQUAL "Release" OR
	    CMAKE_BUILD_TYPE STREQUAL "MinSizeRel" OR
	    CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
		set(WASMTIME_BUILD_TYPE_FLAG "--release")
		set(WASMTIME_BUILD_TYPE "release")
		set(CARGO_PROFILE_PANIC CARGO_PROFILE_RELEASE_PANIC)
	else()
		set(WASMTIME_BUILD_TYPE "debug")
		set(CARGO_PROFILE_PANIC CARGO_PROFILE_DEBUG_PANIC)
    endif()
endif()

if(ANDROID)
	# TODO wasmtime only supports arm64-v8a right now
	if(ANDROID_ABI STREQUAL "armeabi-v7a")
		set(ANDROID_TARGET "armv7-linux-androideabi")
		set(ANDROID_ARCH_SHORT "arm")
	elseif(ANDROID_ABI STREQUAL "arm64-v8a")
		set(ANDROID_TARGET "aarch64-linux-android")
		set(ANDROID_ARCH_SHORT "aarch64")
	elseif(ANDROID_ABI STREQUAL "x86")
		set(ANDROID_TARGET "i686-linux-android")
		set(ANDROID_ARCH_SHORT "i386")
	elseif(ANDROID_ABI STREQUAL "x86_64")
		set(ANDROID_TARGET "x86_64-linux-android")
		set(ANDROID_ARCH_SHORT "x86_64")
	endif()

	set(WASMTIME_BUILD_TARGET "--target=${ANDROID_TARGET}")
endif()

if (BUILD_SHARED_LIBS AND ANDROID)
	message(FATAL_ERROR "Wasmtime cannot be built with BUILD_SHARED_LIBS on Android")
endif()

if(BUILD_SHARED_LIBS)
	if(WIN32)
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/wasmtime.dll.lib)
	elseif(APPLE)
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.dylib)
	else()
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.so)
	endif()
else()
	if(WIN32)
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/wasmtime.lib)
	elseif(ANDROID)
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${ANDROID_TARGET}/${WASMTIME_BUILD_TYPE}/libwasmtime.a)
	else()
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.a)
	endif()
endif()

if(ANDROID)
	# Rust attempts to use libgcc.a on NDK versions r23-beta3 and up
	# but it has been replaced with libunwind.a (rust-lang/rust#85806)
	file(WRITE ${CMAKE_BINARY_DIR}/libgcc.a "INPUT(-lunwind)")
	# The version of the clang compiler is part of the libunwind.a path
	file(STRINGS ${ANDROID_TOOLCHAIN_ROOT}/AndroidVersion.txt CLANG_VERSION_FILE)
	list(GET CLANG_VERSION_FILE 0 CLANG_VERSION)

	# Some crates use the compiler directly, environment variables
	# are set to make them use the Android compiler
	set(WASMTIME_PREBUILD_COMMAND ${CMAKE_COMMAND} -E env
	CC=${ANDROID_TOOLCHAIN_ROOT}/bin/clang
	AR=${ANDROID_TOOLCHAIN_ROOT}/bin/llvm-ar
	"RUSTFLAGS=-L ${CMAKE_SYSROOT}/usr/lib/${ANDROID_TARGET}/${ANDROID_NATIVE_API_LEVEL} \
		-L ${ANDROID_TOOLCHAIN_ROOT}/lib64/clang/${CLANG_VERSION}/lib/linux/${ANDROID_ARCH_SHORT} \
		-L ${CMAKE_BINARY_DIR} -C linker=${ANDROID_TOOLCHAIN_ROOT}/bin/ld")
endif()
include(ExternalProject)
find_program(WASMTIME_CARGO_BINARY cargo)
if(NOT WASMTIME_CARGO_BINARY)
    message(FATAL_ERROR [["cargo" was not found. Ensure "cargo" is in PATH. Aborting...]])
endif()
ExternalProject_Add(
	wasmtime-crate
	DOWNLOAD_COMMAND ""
	CONFIGURE_COMMAND ""
	INSTALL_COMMAND "${WASMTIME_INSTALL_COMMAND}"
        BUILD_COMMAND
            ${CMAKE_COMMAND} -E env ${CARGO_PROFILE_PANIC}=abort
            ${WASMTIME_PREBUILD_COMMAND} ${WASMTIME_CARGO_BINARY} build ${WASMTIME_BUILD_TYPE_FLAG} ${WASMTIME_USER_CARGO_BUILD_OPTIONS} ${WASMTIME_BUILD_TARGET}
	USES_TERMINAL_BUILD TRUE
	BINARY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/artifact
        BUILD_ALWAYS ${WASMTIME_ALWAYS_BUILD}
	BUILD_BYPRODUCTS ${WASMTIME_BUILD_PRODUCT})
add_library(wasmtime INTERFACE)
add_dependencies(wasmtime wasmtime-crate)

if(BUILD_SHARED_LIBS)
	if(NOT WIN32)
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-rpath='$ORIGIN'")
	endif()
	target_link_libraries(wasmtime INTERFACE ${WASMTIME_BUILD_PRODUCT})
else()
	if(WIN32)
		target_compile_options(wasmtime INTERFACE -DWASM_API_EXTERN= -DWASI_API_EXTERN=)
		target_link_libraries(wasmtime INTERFACE ${WASMTIME_BUILD_PRODUCT}
			ws2_32 advapi32 userenv ntdll shell32 ole32 bcrypt)
	elseif(APPLE OR ANDROID)
		target_link_libraries(wasmtime INTERFACE ${WASMTIME_BUILD_PRODUCT})
	else()
		target_link_libraries(wasmtime INTERFACE ${WASMTIME_BUILD_PRODUCT}
			pthread dl m)
	endif()
endif()

target_include_directories(wasmtime INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/include)

include(GNUInstallDirs)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/include/wasmtime.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/wasi.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/doc-wasm.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/wasm.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/wasm.hh
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/wasmtime
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${WASMTIME_BUILD_PRODUCT}
	DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
rust-wasmtime (21.0.2+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Bump gimli and object dependencies (Closes: #1090390, #1091602).

 -- Peter Michael Green <plugwash@debian.org>  Thu, 02 Jan 2025 19:56:39 +0000

rust-wasmtime (21.0.2+dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * update copyright info:
    + exclude more potentially non-DFSG binary code
    + update coverage
  * bump project versions in virtual packages and autopkgtests
  * declare build-dependencies unconditionally,
    i.e. drop broken nocheck annotations
  * update and unfuzz patches
  * update (build-)dependencies
    for crates anyhow gimli target-lexicon

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 16 Nov 2024 23:20:06 +0100

=== debian/control ===
Source: rust-wasmtime
Section: rust
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-rust,
 librust-tempfile-3+default-dev,
 librust-anyhow-1+default-dev,
 librust-anyhow-1+std-dev,
 librust-arbitrary-1+default-dev,
 librust-bincode-1+default-dev,
 librust-bumpalo-3+default-dev,
 librust-capstone-0.11+default-dev,
 librust-gimli-0.31+read-dev,
 librust-hashbrown-0.14-dev,
 librust-log-0.4-dev,
 librust-regalloc2-0.9+checker-dev,
 librust-regalloc2-0.9+default-dev,
 librust-serde-1+default-dev,
 librust-serde-1+derive-dev,
 librust-sha2-0.10+default-dev,
 librust-similar-2+default-dev,
 librust-smallvec-1+default-dev,
 librust-smallvec-1+union-dev,
 librust-souper-ir-2+default-dev,
 librust-target-lexicon-0.12+default-dev,
 rustfmt,
Maintainer: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/debian/rust-wasmtime.git
Vcs-Browser: https://salsa.debian.org/debian/rust-wasmtime
Homepage: https://wasmtime.dev/
Rules-Requires-Root: no

Package: librust-cranelift-dev
Architecture: all
Multi-Arch: foreign
Depends:
 librust-anyhow-1+default-dev,
 librust-anyhow-1+std-dev,
 librust-arbitrary-1+default-dev,
 librust-bincode-1+default-dev,
 librust-bumpalo-3+default-dev,
 librust-capstone-0.11+default-dev,
 librust-codespan-reporting-0.11+default-dev,
 librust-gimli-0.31+read-dev,
 librust-hashbrown-0.14-dev,
 librust-log-0.4-dev,
 librust-regalloc2-0.9+checker-dev,
 librust-regalloc2-0.9+default-dev,
 librust-serde-1+default-dev,
 librust-serde-1+derive-dev,
 librust-sha2-0.10+default-dev,
 librust-smallvec-1+default-dev,
 librust-smallvec-1+union-dev,
 librust-souper-ir-2+default-dev,
 librust-target-lexicon-0.12+default-dev,
 rustfmt,
 ${misc:Depends},
Provides:
 librust-cranelift-0.108+core-dev (= ${binary:Version}),
 librust-cranelift-0.108+default-dev (= ${binary:Version}),
 librust-cranelift-0.108+std-dev (= ${binary:Version}),
 librust-cranelift-0.108-dev (= ${binary:Version}),
 librust-cranelift-0.108.2-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.108+default-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-bforest-0.108-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-bforest-0.108.2-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-codegen-0.108+default-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.108-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.108.2-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-meta-0.108+default-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-meta-0.108-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-meta-0.108.2-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-shared-0.108+default-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-codegen-shared-0.108-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-codegen-shared-0.108.2-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-control-0.108+chaos-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.108+default-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.108-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.108.2-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-entity-0.108+default-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.108+enable-serde-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.108-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.108.2-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-frontend-0.108+core-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.108+default-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.108+std-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.108-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.108.2-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-isle-0.108+default-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.108+logging-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.108+fancy-errors-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.108-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.108.2-dev (= ${rust:Version:librust-cranelift-isle-dev}),
Description: low-level retargetable code generator - Rust source code
 Cranelift is a low-level retargetable code generator.
 It translates a target-independent intermediate representation
 into executable machine code.
 .
 This package contains the source for the Rust cranelift crate,
 for use with cargo.

=== debian/tests/control ===
# check single-feature tests only on amd64
# skip official architectures unsupported by crate cranelift-codegen

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.108.2
 --all-targets --all-features
Features: test-name=cranelift:@
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.108-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.108.2
 --all-targets
Features: test-name=cranelift:default
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.108+default-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.108.2
 --all-targets --no-default-features
Features: test-name=cranelift:
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.108-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.108.2
 --all-targets --no-default-features --features core
Features: test-name=cranelift:core
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.108+core-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.108.2
 --all-targets --no-default-features --features std
Features: test-name=cranelift:std
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.108+std-dev,
Restrictions: allow-stderr

## rust-wasmtime 26.0.1%2Bdfsg

=== debian/watch ===
version: 5
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

Template: Github
Owner: bytecodealliance
Project: wasmtime
Dversion-Mangle: auto
Repacksuffix: +dfsg
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/v(26\.[\d.]+)

## rust-wasmtime 26.0.1+dfsg

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -62,8 +62,8 @@
 # Add rust tests
 create_rust_test(anyref)
 create_rust_wasm(fib-debug wasm32-unknown-unknown)
-create_rust_wasm(tokio wasm32-wasi)
-create_rust_wasm(wasi wasm32-wasi)
+create_rust_wasm(tokio wasm32-wasip1)
+create_rust_wasm(wasi wasm32-wasip1)
 create_rust_wasm(component wasm32-unknown-unknown)
 create_rust_test(epochs)
 create_rust_test(externref)

=== crates/c-api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(wasmtime C)

set(WASMTIME_USER_CARGO_BUILD_OPTIONS "" CACHE STRING "Additional cargo flags (such as --features) to apply to the build command")
option(BUILD_SHARED_LIBS "Build using shared libraries" OFF)
option(WASMTIME_ALWAYS_BUILD "If cmake should always invoke cargo to build wasmtime" ON)
option(WASMTIME_FASTEST_RUNTIME "Set flags designed to optimize runtime performance" OFF)
set(WASMTIME_TARGET "" CACHE STRING "Rust target to build for")

if(WASMTIME_TARGET STREQUAL "")
  execute_process(COMMAND rustc -vV OUTPUT_VARIABLE RUSTC_VERSION)
  string(REGEX MATCH "host: ([^ \n]*)" RUSTC_HOST ${RUSTC_VERSION})
  string(STRIP ${CMAKE_MATCH_1} RUSTC_HOST_TARGET)
  set(WASMTIME_TARGET ${RUSTC_HOST_TARGET})
endif()

include(cmake/features.cmake)

if(WASMTIME_FASTEST_RUNTIME)
  set(WASMTIME_BUILD_TYPE_FLAG "--profile=fastest-runtime")
  set(WASMTIME_BUILD_TYPE "fastest-runtime")
  set(CARGO_PROFILE_PANIC CARGO_PROFILE_RELEASE_PANIC)
else()
  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(WASMTIME_BUILD_TYPE "debug")
    set(CARGO_PROFILE_PANIC CARGO_PROFILE_DEBUG_PANIC)
  else()
    set(WASMTIME_BUILD_TYPE_FLAG "--release")
    set(WASMTIME_BUILD_TYPE "release")
    set(CARGO_PROFILE_PANIC CARGO_PROFILE_RELEASE_PANIC)
  endif()
endif()

set(WASMTIME_TARGET_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_TARGET}/${WASMTIME_BUILD_TYPE})

if(WASMTIME_TARGET MATCHES "darwin")
  set(WASMTIME_SHARED_FILES libwasmtime.dylib)
  set(WASMTIME_STATIC_FILES libwasmtime.a)
elseif(WASMTIME_TARGET MATCHES "windows-gnu")
  set(WASMTIME_SHARED_FILES libwasmtime.dll.a wasmtime.dll)
  set(WASMTIME_STATIC_FILES libwasmtime.a)
elseif(WASMTIME_TARGET MATCHES "windows-msvc")
  set(WASMTIME_SHARED_FILES wasmtime.dll.lib wasmtime.dll)
  set(WASMTIME_STATIC_FILES wasmtime.lib)
else()
  set(WASMTIME_SHARED_FILES libwasmtime.so)
  set(WASMTIME_STATIC_FILES libwasmtime.a)
endif()

list(TRANSFORM WASMTIME_SHARED_FILES PREPEND ${WASMTIME_TARGET_DIR}/)
list(TRANSFORM WASMTIME_STATIC_FILES PREPEND ${WASMTIME_TARGET_DIR}/)

include(ExternalProject)
find_program(WASMTIME_CARGO_BINARY cargo)
if(NOT WASMTIME_CARGO_BINARY)
    message(FATAL_ERROR [["cargo" was not found. Ensure "cargo" is in PATH. Aborting...]])
endif()
ExternalProject_Add(
    wasmtime-crate
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND ""
    INSTALL_COMMAND "${WASMTIME_INSTALL_COMMAND}"
    BUILD_COMMAND
        ${CMAKE_COMMAND} -E env ${CARGO_PROFILE_PANIC}=abort
        ${WASMTIME_CARGO_BINARY} build
          --target ${WASMTIME_TARGET}
          --package wasmtime-c-api
          ${WASMTIME_BUILD_TYPE_FLAG}
          ${WASMTIME_FEATURES}
          ${WASMTIME_USER_CARGO_BUILD_OPTIONS}
    USES_TERMINAL_BUILD TRUE
    # Note that this is used as the cwd for the cargo invocation itself, build
    # byproducts go in the `target` directory at the top-level.
    BINARY_DIR ${CMAKE_CURRENT_SOURCE_DIR}
    BUILD_ALWAYS ${WASMTIME_ALWAYS_BUILD}
    BUILD_BYPRODUCTS ${WASMTIME_SHARED_FILES} ${WASMTIME_STATIC_FILES})
add_library(wasmtime INTERFACE)
add_dependencies(wasmtime wasmtime-crate)

if(BUILD_SHARED_LIBS)
    if(NOT WASMTIME_TARGET MATCHES "windows")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-rpath='$ORIGIN'")
    endif()
    list(GET WASMTIME_SHARED_FILES 0 WASMTIME_SHARED_LIB_TO_LINK)
    target_link_libraries(wasmtime INTERFACE ${WASMTIME_SHARED_LIB_TO_LINK})
else()
    if(WASMTIME_TARGET MATCHES "windows")
        target_compile_options(wasmtime INTERFACE -DWASM_API_EXTERN= -DWASI_API_EXTERN=)
        target_link_libraries(wasmtime INTERFACE ${WASMTIME_STATIC_FILES}
            ws2_32 advapi32 userenv ntdll shell32 ole32 bcrypt)
    elseif(WASMTIME_TARGET MATCHES "darwin")
        target_link_libraries(wasmtime INTERFACE ${WASMTIME_STATIC_FILES})
    else()
        target_link_libraries(wasmtime INTERFACE ${WASMTIME_STATIC_FILES}
            pthread dl m)
    endif()
endif()

target_include_directories(wasmtime INTERFACE ${CMAKE_BINARY_DIR}/include)
set(WASMTIME_HEADER_DST ${CMAKE_BINARY_DIR}/include)
include(cmake/install-headers.cmake)

include(GNUInstallDirs)
install(SCRIPT ${CMAKE_CURRENT_SOURCE_DIR}/cmake/install-headers.cmake)
install(FILES ${WASMTIME_SHARED_FILES} ${WASMTIME_STATIC_FILES}
        DESTINATION ${CMAKE_INSTALL_LIBDIR})

if(WASMTIME_TARGET MATCHES "darwin")
  # Postprocess the macOS dylib a bit to have a more reasonable `LC_ID_DYLIB`
  # directive than the default one that comes out of the linker when typically
  # doing `cargo build`. For more info see #984
  set(INSTALLED_LIB ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/libwasmtime.dylib)
  install(CODE "execute_process(COMMAND install_name_tool -id \"@rpath/libwasmtime.dylib\" ${INSTALLED_LIB})")
endif()

set(DOXYGEN_CONF_IN ${CMAKE_CURRENT_SOURCE_DIR}/doxygen.conf.in)
set(DOXYGEN_CONF_OUT ${CMAKE_BINARY_DIR}/doxygen.conf)
configure_file(${DOXYGEN_CONF_IN} ${DOXYGEN_CONF_OUT})
add_custom_target(doc
    COMMAND doxygen ${DOXYGEN_CONF_OUT}
    DEPENDS ${WASMTIME_GENERATED_CONF_H} ${DOXYGEN_CONF_OUT}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_dependencies(doc headers-to-doc)

file(GLOB headers "include/*.h")
add_custom_target(headers-to-doc
  COMMAND
    ${CMAKE_COMMAND}
      -DWASMTIME_HEADER_DST=${CMAKE_BINARY_DIR}/include
      -P ${CMAKE_CURRENT_SOURCE_DIR}/cmake/install-headers.cmake
  DEPENDS ${headers})

=== debian/changelog ===
rust-wasmtime (26.0.1+dfsg-4) unstable; urgency=medium

  * rename patches 2001_capstone -> 1001_capstone
    and 2001_memmap2 -> 1001_memmap2
  * declare compliance with Debian Policy 4.7.2
  * reduce patch 2001_target-lexicon
    and rename to 2001_pulley-interpreter
    to reflect that it now only avoids crate pulley-interpreter
  * add patch 1001_codespan-reporting
    to accept newer minor version of crate codespan-reporting;
    relax (build-)dependency for crate codespan-reporting;
    closes: bug#1117629, thanks to Nadzeya Hutsko
  * update DEP-3 patch headers

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 09 Oct 2025 00:25:16 +0200

rust-wasmtime (26.0.1+dfsg-3) unstable; urgency=medium

  * drop patch 2002_no_feature_jit, obsoleted by upstream changes;
    add patch 2001_memmap2 to accept newer branches of crate memmap2;
    add patch 2001_wasmtime-jit-icache-coherence
    to add path hint for embedded crate wasmtime-jit-icache-coherence;
    provide crates cranelift-jit wasmtime-jit-icache-coherence;
    closes: bug#1095152, thanks to Maytham Alsudany and Hilko Bengen
  * provide virtual package for and autopkgtest cranelift features
    frontend interpreter jit module native object
  * simplify patch 2001_capstone;
    tighten (build-)dependencies for crate capstone
  * add patch 2004 to break cyclic dependency
    (see bug#1094199)
  * extend patch 2002_no_windows
    to cover crates cranelift-jit wasmtime-jit-icache-coherence
  * autopkgtest crate wasmtime-jit-icache-coherence

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 18 Feb 2025 10:10:52 +0100

rust-wasmtime (26.0.1+dfsg-2) unstable; urgency=medium

  * virtually provide unversioned crates
  * relax patch 2001_capstone to accept newer branch;
    relax (build-)dependency for crate capstone;
    closes: bug#1095629, thanks to NoisyCoil

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 11 Feb 2025 20:08:53 +0100

rust-wasmtime (26.0.1+dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * bump project versions in virtual packages and autopkgtests
  * update and unfuzz patches
  * bump (build-)dependency for crate regalloc2
  * stop (build-)depend on package for crate arbitrary

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 09 Feb 2025 22:22:08 +0100

rust-wasmtime (23.0.3+dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * add metadata about upstream project
  * update git-buildpackage config:
    + filter out debian subdir
    + improve usage comment
  * update watch file:
    + mangle upstream version
    + improve filename mangling
    + use Github API
  * bump project versions in virtual packages and autopkgtests
  * update and unfuzz patches
  * (build-)depend on packages
    for crates env_logger object thiserror
  * update copyright info: update coverage
  * provide crates cranelift-bitset cranelift-interpreter
    cranelift-object cranelift-reader

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 09 Feb 2025 12:16:24 +0100

rust-wasmtime (21.0.2+dfsg-3) unstable; urgency=medium

  * provide crates cranelift-module cranelift-native;
    (build-)depend on packages for crates libc serde_derive;
    tighten (build-)dependencies for crates serde regalloc2 smallvec;
    see bug#1095152

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 09 Feb 2025 01:35:56 +0100

rust-wasmtime (21.0.2+dfsg-2) unstable; urgency=medium

  * update and unfuzz patches
  * fix clean target;
    closes: bug#1095429, thanks to NoisyCoil
  * drop old superseded make rule
  * fix build-depend (not only depend) on package
    for crate codespan-reporting
  * wrap and sort control files,
    with shortening options -ast
  * (build-)depend on package for crate postcard

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 09 Feb 2025 00:45:33 +0100

=== debian/control ===
Source: rust-wasmtime
Section: rust
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-rust,
 librust-anyhow-1+default-dev,
 librust-anyhow-1+std-dev,
 librust-bincode-1+default-dev,
 librust-bumpalo-3+default-dev,
 librust-capstone-0.13+default-dev,
 librust-cfg-if-1+default-dev,
 librust-codespan-reporting-dev (<< 0.13),
 librust-env-logger-0.11+default-dev,
 librust-gimli-0.31+read-dev,
 librust-hashbrown-0.14-dev,
 librust-libc-0.2-dev,
 librust-log-0.4-dev,
 librust-memmap2-0.9+default-dev,
 librust-object-0.36+elf-dev,
 librust-object-0.36+read-core-dev,
 librust-postcard-1+alloc-dev,
 librust-regalloc2-0.10+checker-dev,
 librust-regalloc2-0.10+default-dev,
 librust-regalloc2-0.10+enable-serde-dev,
 librust-region-3+default-dev,
 librust-serde-1+alloc-dev,
 librust-serde-derive-1+default-dev,
 librust-sha2-0.10+default-dev,
 librust-similar-2+default-dev,
 librust-smallvec-1+default-dev,
 librust-smallvec-1+serde-dev,
 librust-smallvec-1+union-dev,
 librust-souper-ir-2+default-dev,
 librust-target-lexicon-0.12+default-dev,
 librust-tempfile-3+default-dev,
 librust-thiserror-1+default-dev,
 rustfmt,
Maintainer: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian/rust-wasmtime.git
Vcs-Browser: https://salsa.debian.org/debian/rust-wasmtime
Homepage: https://wasmtime.dev/
Rules-Requires-Root: no

Package: librust-cranelift-dev
Architecture: all
Multi-Arch: foreign
Depends:
 librust-anyhow-1+default-dev,
 librust-anyhow-1+std-dev,
 librust-bincode-1+default-dev,
 librust-bumpalo-3+default-dev,
 librust-capstone-0.13+default-dev,
 librust-cfg-if-1+default-dev,
 librust-codespan-reporting-dev (<< 0.13),
 librust-env-logger-0.11+default-dev,
 librust-gimli-0.31+read-dev,
 librust-hashbrown-0.14-dev,
 librust-libc-0.2-dev,
 librust-log-0.4-dev,
 librust-memmap2-0.9+default-dev,
 librust-object-0.36+elf-dev,
 librust-object-0.36+read-core-dev,
 librust-postcard-1+alloc-dev,
 librust-regalloc2-0.10+checker-dev,
 librust-regalloc2-0.10+default-dev,
 librust-regalloc2-0.10+enable-serde-dev,
 librust-region-3+default-dev,
 librust-serde-1+alloc-dev,
 librust-serde-derive-1+default-dev,
 librust-sha2-0.10+default-dev,
 librust-smallvec-1+default-dev,
 librust-smallvec-1+serde-dev,
 librust-smallvec-1+union-dev,
 librust-souper-ir-2+default-dev,
 librust-target-lexicon-0.12+default-dev,
 librust-thiserror-1+default-dev,
 rustfmt,
 ${misc:Depends},
Provides:
 librust-cranelift-0.113+core-dev (= ${binary:Version}),
 librust-cranelift-0.113+default-dev (= ${binary:Version}),
 librust-cranelift-0.113+frontend-dev (= ${binary:Version}),
 librust-cranelift-0.113+interpreter-dev (= ${binary:Version}),
 librust-cranelift-0.113+jit-dev (= ${binary:Version}),
 librust-cranelift-0.113+module-dev (= ${binary:Version}),
 librust-cranelift-0.113+native-dev (= ${binary:Version}),
 librust-cranelift-0.113+object-dev (= ${binary:Version}),
 librust-cranelift-0.113+std-dev (= ${binary:Version}),
 librust-cranelift-0.113-dev (= ${binary:Version}),
 librust-cranelift-0.113.1-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.113+default-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-bforest-0.113-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-bforest-0.113.1-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-bforest-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-bitset-0.113+default-dev (= ${rust:Version:librust-cranelift-bitset-dev}),
 librust-cranelift-bitset-0.113+enable-serde-dev (= ${rust:Version:librust-cranelift-bitset-dev}),
 librust-cranelift-bitset-0.113-dev (= ${rust:Version:librust-cranelift-bitset-dev}),
 librust-cranelift-bitset-0.113.1-dev (= ${rust:Version:librust-cranelift-bitset-dev}),
 librust-cranelift-bitset-dev (= ${rust:Version:librust-cranelift-bitset-dev}),
 librust-cranelift-codegen-0.113+core-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.113+default-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.113+enable-serde-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.113+std-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.113-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.113.1-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-meta-0.113+default-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-meta-0.113-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-meta-0.113.1-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-meta-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-shared-0.113+default-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-codegen-shared-0.113-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-codegen-shared-0.113.1-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-codegen-shared-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-control-0.113+chaos-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.113+default-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.113-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.113.1-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-entity-0.113+default-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.113+enable-serde-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.113-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.113.1-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-frontend-0.113+core-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.113+default-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.113+std-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.113-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.113.1-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-interpreter-0.113+default-dev (= ${rust:Version:librust-cranelift-interpreter-dev}),
 librust-cranelift-interpreter-0.113-dev (= ${rust:Version:librust-cranelift-interpreter-dev}),
 librust-cranelift-interpreter-0.113.1-dev (= ${rust:Version:librust-cranelift-interpreter-dev}),
 librust-cranelift-interpreter-dev (= ${rust:Version:librust-cranelift-interpreter-dev}),
 librust-cranelift-isle-0.113+default-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.113+fancy-errors-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.113+logging-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.113-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.113.1-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-jit-0.113+default-dev (= ${rust:Version:librust-cranelift-jit-dev}),
 librust-cranelift-jit-0.113+selinux-fix-dev (= ${rust:Version:librust-cranelift-jit-dev}),
 librust-cranelift-jit-0.113-dev (= ${rust:Version:librust-cranelift-jit-dev}),
 librust-cranelift-jit-0.113.1-dev (= ${rust:Version:librust-cranelift-jit-dev}),
 librust-cranelift-jit-dev (= ${rust:Version:librust-cranelift-jit-dev}),
 librust-cranelift-module-0.113+core-dev (= ${rust:Version:librust-cranelift-module-dev}),
 librust-cranelift-module-0.113+default-dev (= ${rust:Version:librust-cranelift-module-dev}),
 librust-cranelift-module-0.113+enable-serde-dev (= ${rust:Version:librust-cranelift-module-dev}),
 librust-cranelift-module-0.113+std-dev (= ${rust:Version:librust-cranelift-module-dev}),
 librust-cranelift-module-0.113-dev (= ${rust:Version:librust-cranelift-module-dev}),
 librust-cranelift-module-0.113.1-dev (= ${rust:Version:librust-cranelift-module-dev}),
 librust-cranelift-module-dev (= ${rust:Version:librust-cranelift-module-dev}),
 librust-cranelift-native-0.113+core-dev (= ${rust:Version:librust-cranelift-native-dev}),
 librust-cranelift-native-0.113+default-dev (= ${rust:Version:librust-cranelift-native-dev}),
 librust-cranelift-native-0.113+std-dev (= ${rust:Version:librust-cranelift-native-dev}),
 librust-cranelift-native-0.113-dev (= ${rust:Version:librust-cranelift-native-dev}),
 librust-cranelift-native-0.113.1-dev (= ${rust:Version:librust-cranelift-native-dev}),
 librust-cranelift-native-dev (= ${rust:Version:librust-cranelift-native-dev}),
 librust-cranelift-object-0.113+default-dev (= ${rust:Version:librust-cranelift-object-dev}),
 librust-cranelift-object-0.113-dev (= ${rust:Version:librust-cranelift-object-dev}),
 librust-cranelift-object-0.113.1-dev (= ${rust:Version:librust-cranelift-object-dev}),
 librust-cranelift-object-dev (= ${rust:Version:librust-cranelift-object-dev}),
 librust-cranelift-reader-0.113+default-dev (= ${rust:Version:librust-cranelift-reader-dev}),
 librust-cranelift-reader-0.113-dev (= ${rust:Version:librust-cranelift-reader-dev}),
 librust-cranelift-reader-0.113.1-dev (= ${rust:Version:librust-cranelift-reader-dev}),
 librust-cranelift-reader-dev (= ${rust:Version:librust-cranelift-reader-dev}),
 librust-wasmtime-jit-icache-coherence-26+default-dev (= ${rust:Version:librust-wasmtime-jit-icache-coherence-dev}),
 librust-wasmtime-jit-icache-coherence-26+one-core-dev (= ${rust:Version:librust-wasmtime-jit-icache-coherence-dev}),
 librust-wasmtime-jit-icache-coherence-26-dev (= ${rust:Version:librust-wasmtime-jit-icache-coherence-dev}),
 librust-wasmtime-jit-icache-coherence-26.0-dev (= ${rust:Version:librust-wasmtime-jit-icache-coherence-dev}),
 librust-wasmtime-jit-icache-coherence-26.0.1-dev (= ${rust:Version:librust-wasmtime-jit-icache-coherence-dev}),
 librust-wasmtime-jit-icache-coherence-dev (= ${rust:Version:librust-wasmtime-jit-icache-coherence-dev}),
Description: low-level retargetable code generator - Rust source code
 Cranelift is a low-level retargetable code generator.
 It translates a target-independent intermediate representation
 into executable machine code.
 .
 This package contains the source for the Rust cranelift crate,
 for use with cargo.

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

# resolve crate version
# * get topmost version except prerelease suffix
#   from Cargo.toml file in dir passed as argument
# * source package version if matching upstream part modulo prerelease
# * otherwise append source package version
crate_version = \
 $(shell perl -n \
 -E '/^version\W+\K\d+\.\d+\.\d+/ ' \
 -E 'and say "$(DEB_VERSION_UPSTREAM)" =~ /^\Q$$&\E(?:~[a-z]+\d*)?$$/ ? "$(DEB_VERSION)" : "$$&+$(DEB_VERSION_UPSTREAM_REVISION)" and exit' \
 $1/Cargo.toml)

%:
	dh $@ --sourcedirectory cranelift/umbrella

# unlock dependencies during build
execute_before_dh_auto_configure:
	[ -f Cargo.lock.orig ] || mv Cargo.lock Cargo.lock.orig

# declare version for virtually provided embedded crates
packages = librust-cranelift-dev
vpkgstems_cranelift = \
 bforest bitset codegen codegen-meta codegen-shared control \
 entity frontend interpreter isle jit module native object reader
vpkgstems_wasmtime = jit-icache-coherence
packages_virtual = \
 $(patsubst %,librust-cranelift-%-dev,$(vpkgstems_cranelift)) \
 $(patsubst %,librust-wasmtime-%-dev,$(vpkgstems_wasmtime))
override_dh_gencontrol:
	$(eval librust-cranelift-dev_version = $(call crate_version,cranelift/umbrella))\
	$(eval librust-wasmtime-dev_version = $(call crate_version,.))\
	$(foreach s,$(vpkgstems_cranelift),\
	 $(eval librust-cranelift-$s-dev_version = $(call crate_version,cranelift/$(subst isle,isle/isle,$(subst -,/,$s)))))\
	$(foreach s,$(vpkgstems_wasmtime),\
	 $(eval librust-wasmtime-$s-dev_version = $(librust-wasmtime-dev_version)))\
	set -e; $(foreach p,$(packages),\
	 dh_gencontrol -p$p -- \
	 -v'$($p_version)' \
	 $(foreach q,$(filter-out $p,$(packages) $(packages_virtual)),\
	 -V'rust:Version:$q=$($q_version)');)
	dh_gencontrol --remaining-packages

# avoid cleaning unless source is patched
override_dh_auto_clean:
	grep -q crates/wasi-common/WASI/ Cargo.toml || dh_auto_clean --buildsystem rust

# re-lock dependencies
execute_after_dh_auto_clean:
	[ ! -f Cargo.lock.orig ] || mv -f Cargo.lock.orig Cargo.lock

=== debian/tests/control ===
# check single-feature tests only on amd64
# skip official architectures unsupported by crate cranelift-codegen

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.113.1
 --all-targets --all-features
Features:
 test-name=cranelift:@,
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-cranelift-0.113-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.113.1
 --all-targets
Features:
 test-name=cranelift:default,
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-cranelift-0.113+default-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.113.1
 --all-targets --no-default-features
Features:
 test-name=cranelift:,
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-cranelift-0.113-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.113.1
 --all-targets --no-default-features --features core
Features:
 test-name=cranelift:core,
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-cranelift-0.113+core-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.113.1
 --all-targets --no-default-features --features std
Features:
 test-name=cranelift:std,
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-cranelift-0.113+std-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.113.1
 --all-targets --no-default-features --features frontend
Features:
 test-name=cranelift:frontend,
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-cranelift-0.113+frontend-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.113.1
 --all-targets --no-default-features --features interpreter
Features:
 test-name=cranelift:interpreter,
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-cranelift-0.113+interpreter-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.113.1
 --all-targets --no-default-features --features jit
Features:
 test-name=cranelift:jit,
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-cranelift-0.113+jit-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
Restrictions:
 allow-stderr,

## rust-wasmtime 27.0.0%2Bdfsg

=== debian/changelog ===
rust-wasmtime (27.0.0+dfsg-3) unstable; urgency=high

  * skip autopkgtest-checking more failing features
  * set urgency=high since due to security fixes in previous release

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 30 Nov 2025 10:12:41 +0100

rust-wasmtime (27.0.0+dfsg-2) unstable; urgency=high

  * update watch file: limit to match v28
  * add patch cherry-picked upstream
    to prevent using shared memories;
    CVE-2025-64345;
    fixes bug#1120699, thanks to Salvatore Bonaccorso
  * raise urgency due to security bugfix

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 14 Nov 2025 22:47:25 +0100

rust-wasmtime (27.0.0+dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * update watch file: limit to match v27
  * bump project versions in virtual packages and autopkgtests
  * update and unfuzz patches
  * tighten (build-)dependencies for crate serde

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 14 Nov 2025 15:36:34 +0100

rust-wasmtime (26.0.1+dfsg-10) unstable; urgency=medium

  * skip autopkgtest-checking more features
    apparently unsupported alone

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 22 Oct 2025 09:03:16 +0200

rust-wasmtime (26.0.1+dfsg-9) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix build failure with rustc 1.89

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 20 Oct 2025 19:39:25 +0200

rust-wasmtime (26.0.1+dfsg-8) unstable; urgency=medium

  * fix autopkgtest more

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 19 Oct 2025 22:05:21 +0200

rust-wasmtime (26.0.1+dfsg-7) unstable; urgency=medium

  * update watch file:
    + use file format 5
    + limit to match v26
  * fix patch 2004
  * fix autopkgtest

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 12 Oct 2025 11:59:22 +0200

rust-wasmtime (26.0.1+dfsg-6) unstable; urgency=medium

  * fix extend patch 2001_pulley-interpreter
  * (build-)depend on packages
    for crates arbitrary rustc-hash;
    depend on package for crate similar;
    tighten dependencies
    for crates gimli hashbrown object regalloc2
    souper-ir target-lexicon;
    stop depend on package for crate bincode;
    provide cranelift-bitset feature arbitrary;
    provide cranelift-codegen features
    all-native-arch arm64 disas incremental-cache isle-errors
    isle-in-source-tree riscv64 s390x souper-harvest timing unwind x86
  * extend autopkgtest to cover all embedded crates

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 11 Oct 2025 16:38:36 +0200

rust-wasmtime (26.0.1+dfsg-5) unstable; urgency=medium

  * tighten build-dependency for crate codespan-reporting
  * build whole workspace (not only cranelift subset);
    update and unfuzz patches;
    build-depend on packages
    for crates async-trait base64 bytes bytesize cap-std
    clap clap_complete directories-next filetime futures gimli
    humantime indicatif itertools libm libtest-mimic memfd
    pretty-env-logger psm serde_json sptr toml tracing
    walkdir wasmparser wat zstd;
    tighten build-dependencies
    for crates hashbrown libc object postcard regalloc2 serde
    souper-ir target-lexicon;
    stop build-depend on packages for crate bincode

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 11 Oct 2025 14:18:53 +0200
